Subject: Re: [PATCH net-next 5/5] net: sctp: fix and consolidate SCTP checksumming code

From: Daniel Borkmann <[email-masked]>
Date: Mon, 04 Nov 2013 22:10:16 +0100

On 11/04/2013 05:10 PM, Vlad Yasevich wrote:
> On 11/04/2013 07:11 AM, Daniel Borkmann wrote:
>> On 10/30/2013 03:29 PM, Vlad Yasevich wrote:
>>> On 10/30/2013 06:50 AM, Daniel Borkmann wrote:
>> [...]
>>> Daniel
>>>
>>> Here is a follow-on idea that might help even more.
>>> What if we put a pointer to skb_checksum_ops() in the skb
>>> somewhere (I was thinking of skb_shinfo).  Then
>>> skb_checksum can simply use the data from there.  This would
>>> allow us to get rid of all the special cases in SCTP that do
>>> checksumming.  We can just set it to partial, set up the right
>>> fields and let HW or SW always do the right thing.
>>
>> I need to think about this a bit. This would certainly have the
>> negative side-effect of a higher skb->truesize usage and thus
>> affecting memory accounting for everyone as we extend
>> skb_shared_info.
>
> You are talking a single pointer here...  The alternative
> is to do a per-protocol table.

Well, that is e.g. 8 more byte per skb, right? ;) I think if we
need these kind of changes in many more places than currently,
then this would make sense indeed.